unit CodeElev;

{ Ramon Romera - dcembre 1996 }
{ repris par Keops dcembre 1997 }
{ juin 1999 }

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, Mask, ExtCtrls;

type
  TCodeEleveForm = class(TForm)
    BitBtnOK: TBitBtn;
    BitBtnAnnuler: TBitBtn;
    PanelTxt1: TPanel;
    MaskCodeEleve: TMaskEdit;
    PanelMask: TPanel;
    PanelCodeEleve: TPanel;
    PanelTxt2: TPanel;
    BitBtnLister: TBitBtn;
    Image2: TImage;
    Image1: TImage;
    procedure TraiterCode(Sender: TObject);
    procedure MaskCodeEleveChange(Sender: TObject);
    procedure BitBtnListerClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MaskCodeEleveKeyPress(Sender: TObject; var Key: Char);
  private
    { Dclarations private }
  public
    { Dclarations public }
    procedure MontreLesScores;
    function Identification(var nom,prenom,classe : string; atShow : boolean) : TModalResult;
    procedure InscrisScore(theme,prog : string;note : integer);
  end;


implementation
{$R *.DFM}
Uses
  Inscrip, UScore, UConst, ListCode, Scores, KTools;

procedure TCodeEleveForm.TraiterCode(Sender: TObject);
var InscriptionForm : TInscriptionForm;
begin
  if PanelCodeEleve.Caption='' then begin
          (*Application.*)MessageBox(Handle,#13+
            '  CODE VIDE ! '+#13+
            '  Tape 1  8 caractres (lettres ou chiffres)  '+#13,
            'Identification LiliMath', mb_iconstop or mb_Ok);
          MaskCodeEleve.SetFocus;
  end else begin
     ReadIdent(PanelCodeEleve.Caption,IdentEleve);
     if IdentEleve.Nom='' then begin
             if (*Application.*)MessageBox(Handle,#13+
                       '    CODE INCONNU !                     '+#13+#13+
                       '    Faut-il faire une inscription ?    '+#13,
                       'Idnetification LiliMath',
                        mb_IconQuestion or mb_OkCancel)<> mrCancel
                then begin
                     Visible:=false;
                     InscriptionForm:=TInscriptionForm.Create(Self);
                     try
                        InscriptionForm.LeCodeDeLeleve:=PanelCodeEleve.Caption;
                        ModalResult:=InscriptionForm.ShowModal;
                        If ModalResult<>mrCancel then CodeEleve:=PanelCodeEleve.Caption;
                     finally
                            InscriptionForm.Free;
                     end;
                     Visible:=true;
                end;
             MaskCodeEleve.SetFocus;
     end else begin
         CodeEleve:=PanelCodeEleve.Caption;
         ModalResult:=mrOK;
     end;
  end;
end;


procedure TCodeEleveForm.MaskCodeEleveChange(Sender: TObject);
var _i: byte;
    _s: TStr8;
    _ss: TStr8;
    CEleve : TStr8;
begin
  CEleve:=MaskCodeEleve.Text;
  _i:=1;
  while _i<=length(CEleve) do begin
        if (CEleve[_i]=' ') or (ord(CEleve[_i])>126)
           then Delete(CEleve,_i,1)
           else inc(_i);
  end;
  (*
  for _i:=1 to length(CEleve) do
   if (CEleve[_i]=' ') or (ord(CEleve[_i])>126) then Delete(CEleve,_i,1);
  *)
  _ss:=CEleve;
  PanelCodeEleve.Caption:=CEleve;
  _s:='?';
  if Length(_ss)<8 then
   for _i:=Length(_ss) to 8 do insert(_ss,_s,_i);
  MaskCodeEleve.Text:=_ss;
end;


procedure TCodeEleveForm.BitBtnListerClick(Sender: TObject);
var
   ListeCodesForm : TListeCodesForm;
//   i : integer;
begin
    (*Visible:=false;*)
    ListeCodesForm:=TListeCodesForm.Create(Self);
    try
    If ListeCodesForm.ShowModal=mrOk then
         if ListeCodesForm.ListBoxCodes.ItemIndex <> -1 then begin
            MaskCodeEleve.Text:=Copy(ListeCodesForm.ListBoxCodes.Items.Strings[ListeCodesForm.ListBoxCodes.ItemIndex],2,9);
            {PanelCodeEleve.Caption:=ListeCodesForm.ListBoxCodes.Items.Strings[ListeCodesForm.ListBoxCodes.ItemIndex];}
         end;
    finally
    ListeCodesForm.Free;
    end;
    (*Visible:=true;*)
end;

procedure TCodeEleveForm.FormCreate(Sender: TObject);
var s : string;
begin
  { MessageDlg('  MemAvail: '+IntToStr(MemAvail)+'  ', mtInformation,
      [mbOk], 0);}
  if (paramCount<>0) and (CodeEleve='') then begin
     s:=ParamStr(ParamCount);
     If UpperCase(ExtractFileExt(s))<>'.CFG' then begin
        CodeEleve:=s;
        ReadIdent(CodeEleve,IdentEleve);
        If (IdentEleve.Nom='') and (IdentEleve.prenom='') then CodeEleve:=''; 
     end;
   end;
end;

procedure TCodeEleveForm.MontreLesScores;
var ScoresEleveForm : TScoresEleveForm;
begin
     ScoresEleveForm:=TScoresEleveForm.Create(Self);
     Try
        ScoresEleveForm.ShowModal;
     Finally
            ScoresEleveForm.Free;
     end;
end;

function TCodeEleveForm.Identification(var nom,prenom,classe : string; AtShow : boolean) : TModalResult;
var deja : boolean;
begin
     MaskCodeEleve.Text:=CodeEleve;
     If AtShow
        then deja:=(IdentEleve.Nom<>'')
        else begin
             deja:=false;
        end;
     if not deja
        then Result:=ShowModal
        else Result:=idOK;
     If Result=idOk then begin
        nom:=ASCII2WIN(IdentEleve.nom);
        prenom:=ASCII2WIN(IdentEleve.prenom);
        classe:=ASCII2WIN(IdentEleve.classe);
     end;
end;

procedure TCodeEleveForm.MaskCodeEleveKeyPress(Sender: TObject;
  var Key: Char);
begin
     if Key=#13 then begin
        Key:=#0;
        TraiterCode(Sender);
     end;
end;

procedure TCodeEleveForm.InscrisScore(theme,prog : string;note : integer);
begin
     ScoreEleve.theme:=theme;
     ScoreEleve.prog:=prog;
     GetScore(CodeEleve,ScoreEleve,IdentEleve);
     inc(ScoreEleve.nbEssais);
     if note>ScoreEleve.result then ScoreEleve.result:=note;
     ScoreUpDate(CodeEleve, ScoreEleve);
end;


end.
