unit KTools;

interface

uses WinTypes,WinProcs,Classes,SysUtils;

(* Conversion ASCII *)
function ASCII2WIN(source : string) : string;
function WIN2ASCII(source : string) : string;

(* Copy de fichiers par objet Stream *)
function SFileCopy( Const sourcefilename, targetfilename: String ) : boolean;

(* Gestion des fichiers PIF *)
function ChangePIFWorkDir(pifname,workname : string) : boolean;
function ChangePIFFileName(pifname,filename : string) : boolean;
function ChangePIFParameters(pifname,param : string) : boolean;
function ChangePifLili(pifname,filename,param,workname : string) : boolean;

function ShellExecute(hWnd: HWND; Operation, FileName, Parameters,
  Directory: PChar; ShowCmd: Integer): HINST; stdcall;

implementation


function ShellExecute; external 'shell32' name 'ShellExecuteA';

function ASCII2WIN(source : string) : string;
{const
  oem : array [128..255] of char (* le secret *)
  = ('','','','','','','','','','','','','','','','',
     '','','','','','','','','','','','','','','P','',
     '','','','','','','','','','','','','','','','',
     ' ',' ',' ','|','|','|',7'|','|','|','|','|','|','|','|','|','|',
     '|','','','|','','|','|','|','|','|','','','|','','|','',
     '','','','|','|','|','|','|','|','|','|',' ',' ',' ',' ',' ',
     'a','','','','S','o','','t','','','O','d','','','e','',
     '=','','>','<','|','|',':','~','','','','V','','',' ',' ');

var
   l : longint;}
var s : string;
begin
     s:=source+#0;
     oemToAnsi(@s[1],@s[1]);
     {Result:=source;
     For l:=1 to length(result) do
         if ord(result[l])>127
            then Result[l]:=oem[ord(result[l])];}
     Delete(s,length(s),1);
     Result:=s;
end;

function WIN2ASCII(source : string) : string;
{const
  oem : array [128..255] of byte (* le secret *)
  = (32,32,44,102,159,32,197,32,94,32,83,63,32,32,32,32,
     32,39,39,34,34,249,45,196,126,32,83,62,32,32,32,89,
     32,173,67,156,32,157,179,32,32,99,32,34,170,45,114,32,
     167,241,253,32,39,230,227,250,44,32,167,34,172,171,32,168,
     32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,
     32,32,32,32,32,32,32,32,120,32,32,32,32,32,232,225,
     133,160,131,97,132,134,145,135,138,130,136,137,141,161,140,139,
     111,164,149,162,147,111,148,246,237,151,162,150,129,121,233,152
    );
var
   l : longint;}
var s: string;
begin
     s:=source+#0;
     AnsiToOem(@s[1],@s[1]);
     {Result:=source;
     For l:=1 to length(result) do
         if ord(result[l])>127
            then Result[l]:=chr(oem[ord(result[l])]);}
     Delete(s,length(s),1);
     Result:=s;
end;

function SFileCopy( Const sourcefilename, targetfilename: String ) : boolean;
Var
  S, T: TFileStream;
Begin
  result:=false;
  try
     S := TFileStream.Create( sourcefilename, fmOpenRead );
     try
       T := TFileStream.Create( targetfilename,
                                fmOpenWrite or fmCreate or fmShareExclusive );
       try
         result:=(T.CopyFrom(S, S.Size ) = S.Size) ;
       finally
         T.Free;
       end;
     finally
       S.Free;
     end;
  except
     result:=false;
  end;
End;

function ChangePIFWorkDir(pifname,workname : string) : boolean;
var
  f : file;
  p : pchar;
begin
  AssignFile(f,pifName);
  reset(f,1);
  seek(f,101);
  p:=StrAlloc(length(workName)+2);
  StrPCopy(p,WorkName);
  BlockWrite(f,p^,length(workname)+1);
  StrDispose(p);
  CloseFile(f);
end;

function ChangePIFFileName(pifname,filename : string) : boolean;
var
  f : file;
  p : pchar;
begin
  AssignFile(f,PifName);
  reset(f,1);
  seek(f,36);
  p:=StrAlloc(length(FileName)+2);
  StrPCopy(p,FileName);
  BlockWrite(f,p^,length(FileName)+1);
  StrDispose(p);
  CloseFile(f);
end;

function ChangePIFParameters(pifname,param : string) : boolean;
var
  f : file;
  p : pchar;
begin
  AssignFile(f,PifName);
  reset(f,1);
  seek(f,453);
  p:=StrAlloc(length(param)+2);
  StrPCopy(p,param);
  BlockWrite(f,p^,length(param)+1);
  StrDispose(p);
  CloseFile(f);
end;

function ChangePifLili(pifname,filename,param,workname : string) : boolean;
var
  f : file;
  p : pchar;
begin
  AssignFile(f,PifName);
  reset(f,1);
  seek(f,36);
  p:=StrAlloc(length(FileName)+2);
  StrPCopy(p,FileName);
  BlockWrite(f,p^,length(FileName)+1);
  StrDispose(p);
  seek(f,101);
  p:=StrAlloc(length(workName)+2);
  StrPCopy(p,WorkName);
  BlockWrite(f,p^,length(workname)+1);
  StrDispose(p);
  seek(f,453);
  p:=StrAlloc(length(param)+2);
  StrPCopy(p,param);
  BlockWrite(f,p^,length(param)+1);
  StrDispose(p);
  CloseFile(f);
end;

end.
