unit Liliscor;

interface

uses WinTypes, WinProcs, Classes, Forms;

type
  TLiliScore = class(TComponent)
  private
    { Dclarations private }
  protected
    { Dclarations protected }
     Fnom,
     Fprenom,
     Fclasse,
     FTheme,
     FProg : string;
     FNote : integer;
     FAtShow : boolean;
     procedure Initialise;
     function GetCodeEleve : string;
     procedure SetDossierScores(Dossier : string);
     function GetDossierScores : string;
     procedure SetNote( valeur : integer);
  public
    { Dclarations public }
     constructor Create(AOwner: TComponent); override;
     procedure MontrerLesScores;
     procedure MontrerLeScore;
     procedure InscrireScore;
     function Identifier : boolean;

     property CodeEleve : string read GetCodeEleve;
     property DossierScores : string read GetDossierScores write SetDossierScores;
     property Nom : string read FNom write FNom;
     property Prenom : string read FPreNom write FPreNom;
     property Classe : string read FClasse write FClasse;
     property Programme : string read FProg write FProg;
  published
    { Dclarations published }
     property Theme : string read FTheme write FTheme;
     property Note : integer read FNote write SetNote;
  end;

procedure Register;

implementation

uses CodeElev, UScore,UConst, SysUTils;

constructor TLiliScore.Create(AOwner: TComponent);
begin
     inherited Create(AOwner);
     Fnom:='';
     Fprenom:='';
     Fclasse:='';
     FTheme:='';
     FProg:=ExtractFileName(Application.ExeName);
     FProg:=Copy(FProg,1,Pos('.',FProg)-1);
     FNote:=0;
     FAtShow:=true;
end;

procedure TLiliScore.MontrerLesScores;
var  CodeElForm: TCodeEleveForm;
begin
     Application.CreateForm(TCodeEleveForm,CodeElForm);
     Try
     CodeElForm.MontreLesScores;
     finally
        CodeElForm.Free;
     end;
end;

procedure TLiliScore.MontrerLeScore;
var
   s : string;
   ScoreLoc : TScore;
begin
     ScoreLoc.NbEssais:=0;
     ScoreLoc.Result:=0;
     ScoreLoc.theme:=Ftheme;
     ScoreLoc.prog:=Fprog;
     GetScore(CodeEleve,ScoreLoc,IdentEleve);
     s:= inttostr(Fnote)+' : score actuel'#13+
         inttostr(ScoreLoc.NbEssais)+' : nombre d''essais'#13+
         inttostr(ScoreLoc.Result)+' : score inscrit'#0;
     Application.MessageBox(@s[1],'Etat du Score',mb_OK);
end;

function TLiliScore.Identifier : boolean;
var CodeElForm: TCodeEleveForm;
begin
     Application.CreateForm(TCodeEleveForm,CodeElForm);
     Try
        Result:=(CodeElForm.Identification(Fnom,Fprenom,Fclasse,FAtShow)=idOK);
        FAtShow:=false;
        if (not Result) and (CodeEleve='') then Application.Terminate; (*PostQuitMessage(0);*)
     finally
        CodeElForm.Free;
     end;
end;

procedure TLiliScore.InscrireScore;
var  CodeElForm: TCodeEleveForm;
begin
     Application.CreateForm(TCodeEleveForm,CodeElForm);
     Try
        CodeElForm.InscrisScore(Ftheme,Fprog,Fnote);
     finally
        CodeElForm.Free;
     end;
end;

function TLiliScore.GetDossierScores : string;
begin
     Result:=UScore.DossierScores;
end;

procedure TLiliScore.SetDossierScores(Dossier : string);
begin
     FixeDossierScores(Dossier);
end;

procedure TLiliScore.SetNote( valeur : integer);
begin
     if Valeur<>FNote then begin
        FNote:=Valeur;
        If FNote<0 then FNote:=0;
        If FNote>100 then FNote:=100;
     end;
end;


function TLiliScore.GetCodeEleve : string;
begin
     Result:=UScore.CodeEleve;
end;

procedure TLiliScore.Initialise;
begin
     UScore.Initialise;
end;

procedure Register;
begin
  RegisterComponents('Lilimath', [TLiliScore]);
end;

end.
